<template>
  <section class="lobby">
    <header>
      <h1 class="rc:text--title">{{ lobby.gameBox.name }}</h1>
      <LobbyShareLink :lobby="lobby" may-join />
    </header>

    <div class="teams" v-if="lobby.participants.teams">
      <h2 class="rc:text--subtitle">Players</h2>
      <!-- TODO show teams -->
    </div>
    <div class="players" v-else>
      <h2 class="rc:text--subtitle">
        Players
        <button
          v-if="!isPlayer"
          type="button"
          class="players-join join-button"
          @click="lobbyState.changeTeam(0)"
        >
          Join
        </button>
      </h2>
      <ol class="players-list">
        <li
          v-for="player in lobby.participants.players.asList"
          :key="player.id"
          class="player"
          :class="[
            player.uiMeta?.classNames,
            { self: player.id === lobbyState.self.id },
          ]"
          :style="player.uiMeta?.styles"
        >
          {{ player.name }}
        </li>
      </ol>
    </div>

    <div class="spectators">
      <h2 class="rc:text--subtitle">
        Spectators
        <button
          v-if="isPlayer"
          type="button"
          class="spectators-join join-button"
          @click="lobbyState.changeTeam(null)"
        >
          Join
        </button>
      </h2>
      <ul
        v-if="lobby.participants.spectators.length > 0"
        class="spectators-list"
      >
        <li
          v-for="spectator in lobby.participants.spectators"
          :key="spectator.id"
          class="spectator"
          :class="[
            spectator.uiMeta?.classNames,
            { self: spectator.id === lobbyState.self.id },
          ]"
          :style="spectator.uiMeta?.styles"
        >
          {{ spectator.name }}
        </li>
      </ul>
    </div>

    <template v-if="isCreator">
      <h2 class="rc:sr-only">Controls</h2>
      <button type="button" class="start-game" @click="$emit('start')">
        Start game
      </button>
    </template>

    <div class="game-description" v-html="lobby.gameBox.description"></div>
  </section>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import LobbyShareLink from "@/modules/lobby/LobbyShare.vue";
import { UILobbyState } from "@raining.cards/client";
import { useLobby } from "@/modules/lobby/lobby.state";

export default defineComponent({
  components: { LobbyShareLink },
  props: {
    lobbyState: {
      type: Object as PropType<UILobbyState>,
      required: true,
    },
  },
  emits: ["start"],
  setup(props) {
    const lobby = useLobby(props.lobbyState);
    // todo move to core
    const isCreator = computed(
      () => lobby.value.creator.id === props.lobbyState.self.id
    );
    const isPlayer = computed(
      () =>
        lobby.value.participants.players.asLookup[props.lobbyState.self.id] !=
        null
    );

    return { isCreator, isPlayer, lobby };
  },
});
</script>

<style lang="scss" scoped>
@import "!/styles/mixins/index";
@import "!/styles/variables/index";

.player,
.spectator {
  &::before {
    content: " ";
    white-space: pre;
    font-family: monospace;
    margin: 0 0.5em;
  }
  &.self {
    &::before {
      content: "★";
      vertical-align: top;
      color: darkcyan;
    }
  }
}

.start-game {
  margin-top: $spacing-lg;
  @include action-button;
  padding: $spacing-md $spacing-lg;
}

.join-button {
  @include action-button;
  padding: 0 $spacing-sm;
  font-size: 0.8em;
  margin-bottom: -$spacing-xs;
  margin-left: $spacing-sm;
}

.game-description {
  margin-top: $spacing-xl;
  max-width: 70ch;
  text-align: justify;
  @include user-content;
}

.spectators,
.players {
  margin-top: $spacing-md;
}
</style>
